(** File generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_alpha.Environment.
Require TezosOfOCaml.Proto_alpha.Blinded_public_key_hash.
Require TezosOfOCaml.Proto_alpha.Bootstrap_storage.
Require TezosOfOCaml.Proto_alpha.Commitment_repr.
Require TezosOfOCaml.Proto_alpha.Constants_repr.
Require TezosOfOCaml.Proto_alpha.Contract_storage.
Require TezosOfOCaml.Proto_alpha.Cycle_repr.
Require TezosOfOCaml.Proto_alpha.Delegate_storage.
Require TezosOfOCaml.Proto_alpha.Lazy_storage_diff.
Require TezosOfOCaml.Proto_alpha.Level_repr.
Require TezosOfOCaml.Proto_alpha.Level_storage.
Require TezosOfOCaml.Proto_alpha.Liquidity_baking_migration.
Require TezosOfOCaml.Proto_alpha.Migration_repr.
Require TezosOfOCaml.Proto_alpha.Parameters_repr.
Require TezosOfOCaml.Proto_alpha.Raw_context.
Require TezosOfOCaml.Proto_alpha.Raw_level_repr.
Require TezosOfOCaml.Proto_alpha.Receipt_repr.
Require TezosOfOCaml.Proto_alpha.Round_repr.
Require TezosOfOCaml.Proto_alpha.Script_repr.
Require TezosOfOCaml.Proto_alpha.Seed_storage.
Require TezosOfOCaml.Proto_alpha.Stake_storage.
Require TezosOfOCaml.Proto_alpha.Storage.
Require TezosOfOCaml.Proto_alpha.Storage_sigs.
Require TezosOfOCaml.Proto_alpha.Tez_repr.
Require TezosOfOCaml.Proto_alpha.Token.
Require TezosOfOCaml.Proto_alpha.Vote_storage.

Definition prepare_first_block
  (ctxt : Context.t)
  (typecheck :
    Raw_context.t -> Script_repr.t ->
    M? ((Script_repr.t * option Lazy_storage_diff.diffs) * Raw_context.t))
  (level : int32) (timestamp : Time.t) : M? Raw_context.t :=
  let? '(previous_protocol, ctxt) :=
    Raw_context.prepare_first_block level timestamp ctxt in
  let parametric_value := Raw_context.constants ctxt in
  let ctxt :=
    let ctxt :=
      Raw_context.Cache.(Context.CACHE.set_cache_layout) ctxt
        (Constants_repr.cache_layout parametric_value) in
    Raw_context.Cache.(Context.CACHE.clear) ctxt in
  let? '(ctxt, balance_updates) :=
    match previous_protocol with
    | Raw_context.Genesis param =>
      let? ctxt :=
        Storage.Block_round.(Storage.Simple_single_data_storage.init_value) ctxt
          Round_repr.zero in
      let? first_level := Raw_level_repr.of_int32 level in
      let? ctxt :=
        Storage.Tenderbake.First_level.(Storage_sigs.Single_data_storage.init_value)
          ctxt first_level in
      let init_commitment
        (function_parameter :
          Raw_context.t *
            list
              (Receipt_repr.balance * Receipt_repr.balance_update *
                Receipt_repr.update_origin))
        : Commitment_repr.t ->
        M?
          (Raw_context.t *
            list
              (Receipt_repr.balance * Receipt_repr.balance_update *
                Receipt_repr.update_origin)) :=
        let '(ctxt, balance_updates) := function_parameter in
        fun (function_parameter : Commitment_repr.t) =>
          let '{|
            Commitment_repr.t.blinded_public_key_hash := blinded_public_key_hash;
              Commitment_repr.t.amount := amount
              |} := function_parameter in
          let? '(ctxt, new_balance_updates) :=
            Token.transfer None ctxt
              (Token.Source_infinite Token.Initial_commitments)
              (Token.Sink_container
                (Token.Collected_commitments blinded_public_key_hash)) amount in
          return? (ctxt, (Pervasives.op_at new_balance_updates balance_updates))
        in
      let? '(ctxt, commitments_balance_updates) :=
        List.fold_left_es init_commitment (ctxt, nil)
          param.(Parameters_repr.t.commitments) in
      let? ctxt :=
        Storage.Stake.Last_snapshot.(Storage_sigs.Single_data_storage.init_value)
          ctxt 0 in
      let? ctxt :=
        Seed_storage.init_value
          param.(Parameters_repr.t.constants).(Constants_repr.parametric.initial_seed)
          ctxt in
      let? ctxt := Contract_storage.init_value ctxt in
      let? '(ctxt, bootstrap_balance_updates) :=
        Bootstrap_storage.init_value ctxt typecheck
          param.(Parameters_repr.t.no_reward_cycles)
          param.(Parameters_repr.t.bootstrap_accounts)
          param.(Parameters_repr.t.bootstrap_contracts) in
      let? ctxt := Stake_storage.init_first_cycles ctxt Delegate_storage.pubkey
        in
      let cycle := (Raw_context.current_level ctxt).(Level_repr.t.cycle) in
      let? '(ctxt, deposits_balance_updates) :=
        Delegate_storage.freeze_deposits_do_not_call_except_for_migration ctxt
          cycle nil in
      let? ctxt :=
        Vote_storage.init_value ctxt
          (Level_storage.current ctxt).(Level_repr.t.level_position) in
      let? ctxt := Vote_storage.update_listings ctxt in
      let? '(ctxt, operation_results) :=
        Liquidity_baking_migration.init_value ctxt typecheck in
      let? ctxt :=
        Storage.Pending_migration.Operation_results.(Storage_sigs.Single_data_storage.init_value)
          ctxt operation_results in
      return?
        (ctxt,
          (Pervasives.op_at commitments_balance_updates
            (Pervasives.op_at bootstrap_balance_updates deposits_balance_updates)))
    | Raw_context.Ithaca_012 =>
      let? first_level := Raw_level_repr.of_int32 level in
      let? ctxt :=
        Storage.Tenderbake.First_level.(Storage_sigs.Single_data_storage.update)
          ctxt first_level in
      let ctxt :=
        Storage.Vote.Legacy_listings_size.(Storage_sigs.Single_data_storage.remove)
          ctxt in
      let? ctxt := Vote_storage.update_listings ctxt in
      return? (ctxt, nil)
    end in
  let? balance_updates := Receipt_repr.group_balance_updates balance_updates in
  let ctxt :=
    Storage.Pending_migration.Balance_updates.(Storage_sigs.Single_data_storage.add)
      ctxt balance_updates in
  return? ctxt.

Definition prepare
  (ctxt : Context.t) (level : Int32.t) (predecessor_timestamp : Time.t)
  (timestamp : Time.t)
  : M?
    (Raw_context.t * Receipt_repr.balance_updates *
      list Migration_repr.origination_result) :=
  let? ctxt := Raw_context.prepare level predecessor_timestamp timestamp ctxt in
  Storage.Pending_migration.remove ctxt.
